
// OG King programmer - Lucas Morgan - www.enviral-design.com //

// stupid hacked additions to make it compatible with any lil arduino and general FastLED
// The Glad Scientist - www.thegladscientist.info

//#define USE_OCTOWS2811 don't use teensy
//#include<OctoWS2811.h> dont need teensy
#include<FastLED.h>

// ------------ Change these as neccesary -----------//
//FASTLED normal variables like pin number and brightness and board type and such //
#define LED_PIN     5
#define BRIGHTNESS  10
#define LED_TYPE    WS2812B
#define COLOR_ORDER GRB

//TEENSY aka ORIGINAL variables //
#define NUM_LEDS_PER_STRIP 28
#define NUM_STRIPS 5

CRGB leds[NUM_STRIPS * NUM_LEDS_PER_STRIP];
const int numOfBytes = NUM_LEDS_PER_STRIP * NUM_STRIPS * 3;
const int numLeds = NUM_LEDS_PER_STRIP * NUM_STRIPS;
char inputBuffer[numOfBytes];

// ------------------- Setup -------------------- //
void setup() {
      delay( 3000 ); // power-up safety delay
    FastLED.addLeds<LED_TYPE, LED_PIN, COLOR_ORDER>(leds, numLeds).setCorrection( TypicalLEDStrip ); //used the original numLeds variable as opposed to other NUM_LEDs variable for precision
    FastLED.setBrightness(  BRIGHTNESS );

//  LEDS.addLeds(leds, NUM_LEDS_PER_STRIP); teensy add 
// LEDS.setBrightness(10); teensy brightness
 // delay(500);
  Serial.begin(115200);
  Serial.setTimeout(500);
  LEDS.show();
}

// ------------------- Main Loop -------------------- //
void loop() {
  if(Serial.available() > 0) {
    Serial.readBytes(inputBuffer, numOfBytes);
  }
      for (int j = 0; j < numLeds; j++) {
        leds[j] = CRGB(inputBuffer[(j*3)],inputBuffer[(j*3)+1],inputBuffer[(j*3)+2]);
      }
      LEDS.show();
}
